Blame


1 0e673013 2019-01-02 stsp #!/bin/sh
2 0e673013 2019-01-02 stsp #
3 5aa81393 2020-01-06 stsp # Copyright (c) 2019, 2020 Stefan Sperling <stsp@openbsd.org>
4 0e673013 2019-01-02 stsp #
5 0e673013 2019-01-02 stsp # Permission to use, copy, modify, and distribute this software for any
6 0e673013 2019-01-02 stsp # purpose with or without fee is hereby granted, provided that the above
7 0e673013 2019-01-02 stsp # copyright notice and this permission notice appear in all copies.
8 0e673013 2019-01-02 stsp #
9 0e673013 2019-01-02 stsp # THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
10 0e673013 2019-01-02 stsp # WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
11 0e673013 2019-01-02 stsp # MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
12 0e673013 2019-01-02 stsp # ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
13 0e673013 2019-01-02 stsp # WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
14 0e673013 2019-01-02 stsp # ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
15 0e673013 2019-01-02 stsp # OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
16 0e673013 2019-01-02 stsp
17 0b2899f8 2019-08-18 stsp export GIT_AUTHOR_NAME="Flan Hacker"
18 0b2899f8 2019-08-18 stsp export GIT_AUTHOR_EMAIL="flan_hacker@openbsd.org"
19 0b2899f8 2019-08-18 stsp export GIT_COMMITTER_NAME="$GIT_AUTHOR_NAME"
20 0b2899f8 2019-08-18 stsp export GIT_COMMITTER_EMAIL="$GIT_AUTHOR_EMAIL"
21 0b2899f8 2019-08-18 stsp export GOT_AUTHOR="$GIT_AUTHOR_NAME <$GIT_AUTHOR_EMAIL>"
22 82f6abb8 2019-08-14 stsp export GOT_AUTHOR_8="flan_hac"
23 e600f124 2021-03-21 stsp export GOT_AUTHOR_11="flan_hacker"
24 b1ebc001 2019-08-13 stsp export GOT_LOG_DEFAULT_LIMIT=0
25 11f4fa81 2020-10-01 stsp export GOT_TEST_ROOT="/tmp"
26 7370f802 2022-07-24 op export GOT_IGNORE_GITCONFIG=1
27 c3754a5b 2019-05-10 stsp
28 7b67836a 2019-05-10 stsp export MALLOC_OPTIONS=S
29 7b67836a 2019-05-10 stsp
30 f6cae3ed 2020-09-13 naddy git_init()
31 0e673013 2019-01-02 stsp {
32 0b2899f8 2019-08-18 stsp git init -q "$1"
33 78caff98 2021-09-30 stsp
34 78caff98 2021-09-30 stsp # Switch the default branch to match our test expectations if needed.
35 78caff98 2021-09-30 stsp # Only need to change HEAD since 'git init' did not create any refs.
36 78caff98 2021-09-30 stsp # Relying on implementation details of 'git init' is no problem for us.
37 78caff98 2021-09-30 stsp # We want to be alerted when Git changes fundamental assumptions such
38 78caff98 2021-09-30 stsp # as what an empty repository looks like and where the default branch
39 78caff98 2021-09-30 stsp # is set. In such cases Got's own tooling might well need to change
40 78caff98 2021-09-30 stsp # its behaviour, too, and our tests should fail.
41 78caff98 2021-09-30 stsp # TODO: Update all tests to assume 'main' instead of 'master' and
42 78caff98 2021-09-30 stsp # switch to main here, to match Got's own default.
43 78caff98 2021-09-30 stsp echo "ref: refs/heads/master" > "$1/.git/HEAD"
44 0e673013 2019-01-02 stsp }
45 0e673013 2019-01-02 stsp
46 f6cae3ed 2020-09-13 naddy maybe_pack_repo()
47 b32c4525 2020-01-05 stsp {
48 b32c4525 2020-01-05 stsp local repo="$1"
49 b32c4525 2020-01-05 stsp if [ -n "$GOT_TEST_PACK" ]; then
50 0a26275f 2022-01-03 stsp (cd $repo && gotadmin pack -a > /dev/null)
51 6fa5c67c 2022-01-03 stsp (cd $repo && gotadmin cleanup -a -q)
52 b32c4525 2020-01-05 stsp fi
53 b32c4525 2020-01-05 stsp }
54 b32c4525 2020-01-05 stsp
55 f6cae3ed 2020-09-13 naddy git_commit()
56 0e673013 2019-01-02 stsp {
57 0e673013 2019-01-02 stsp local repo="$1"
58 0e673013 2019-01-02 stsp shift
59 0b2899f8 2019-08-18 stsp (cd $repo && git commit --author="$GOT_AUTHOR" -q -a "$@")
60 b32c4525 2020-01-05 stsp maybe_pack_repo $repo
61 0e673013 2019-01-02 stsp }
62 0e673013 2019-01-02 stsp
63 f6cae3ed 2020-09-13 naddy git_rm()
64 512f0d0e 2019-01-02 stsp {
65 512f0d0e 2019-01-02 stsp local repo="$1"
66 512f0d0e 2019-01-02 stsp shift
67 512f0d0e 2019-01-02 stsp (cd $repo && git rm -q "$@")
68 512f0d0e 2019-01-02 stsp }
69 512f0d0e 2019-01-02 stsp
70 f6cae3ed 2020-09-13 naddy git_show_head()
71 9c4b8182 2019-01-02 stsp {
72 9c4b8182 2019-01-02 stsp local repo="$1"
73 9c4b8182 2019-01-02 stsp (cd $repo && git show --no-patch --pretty='format:%H')
74 9c4b8182 2019-01-02 stsp }
75 9c4b8182 2019-01-02 stsp
76 f6cae3ed 2020-09-13 naddy git_show_branch_head()
77 db32465d 2020-02-07 stsp {
78 db32465d 2020-02-07 stsp local repo="$1"
79 db32465d 2020-02-07 stsp local branch="$2"
80 db32465d 2020-02-07 stsp (cd $repo && git show --no-patch --pretty='format:%H' $branch)
81 db32465d 2020-02-07 stsp }
82 db32465d 2020-02-07 stsp
83 db32465d 2020-02-07 stsp
84 f6cae3ed 2020-09-13 naddy git_show_author_time()
85 bcb49d15 2019-08-14 stsp {
86 bcb49d15 2019-08-14 stsp local repo="$1"
87 01073a5d 2019-08-22 stsp local object="$2"
88 01073a5d 2019-08-22 stsp (cd $repo && git show --no-patch --pretty='format:%at' $object)
89 bcb49d15 2019-08-14 stsp }
90 bcb49d15 2019-08-14 stsp
91 f6cae3ed 2020-09-13 naddy git_show_tagger_time()
92 8e7bd50a 2019-08-22 stsp {
93 8e7bd50a 2019-08-22 stsp local repo="$1"
94 8e7bd50a 2019-08-22 stsp local tag="$2"
95 8e7bd50a 2019-08-22 stsp (cd $repo && git cat-file tag $tag | grep ^tagger | \
96 8e7bd50a 2019-08-22 stsp sed -e "s/^tagger $GOT_AUTHOR//" | cut -d' ' -f2)
97 8e7bd50a 2019-08-22 stsp }
98 8e7bd50a 2019-08-22 stsp
99 f6cae3ed 2020-09-13 naddy git_show_parent_commit()
100 818c7501 2019-07-11 stsp {
101 818c7501 2019-07-11 stsp local repo="$1"
102 70551d57 2020-04-24 stsp local commit="$2"
103 70551d57 2020-04-24 stsp (cd $repo && git show --no-patch --pretty='format:%P' $commit)
104 818c7501 2019-07-11 stsp }
105 818c7501 2019-07-11 stsp
106 f6cae3ed 2020-09-13 naddy git_show_tree()
107 03415a1a 2019-06-02 stsp {
108 03415a1a 2019-06-02 stsp local repo="$1"
109 03415a1a 2019-06-02 stsp (cd $repo && git show --no-patch --pretty='format:%T')
110 03415a1a 2019-06-02 stsp }
111 03415a1a 2019-06-02 stsp
112 f6cae3ed 2020-09-13 naddy trim_obj_id()
113 818c7501 2019-07-11 stsp {
114 9439a990 2020-09-16 naddy local trimcount=$1
115 9439a990 2020-09-16 naddy local id=$2
116 818c7501 2019-07-11 stsp
117 9439a990 2020-09-16 naddy local pat=""
118 9439a990 2020-09-16 naddy while [ "$trimcount" -gt 0 ]; do
119 818c7501 2019-07-11 stsp pat="[0-9a-f]$pat"
120 9439a990 2020-09-16 naddy trimcount=$((trimcount - 1))
121 818c7501 2019-07-11 stsp done
122 818c7501 2019-07-11 stsp
123 818c7501 2019-07-11 stsp echo ${id%$pat}
124 818c7501 2019-07-11 stsp }
125 818c7501 2019-07-11 stsp
126 f6cae3ed 2020-09-13 naddy git_commit_tree()
127 03415a1a 2019-06-02 stsp {
128 03415a1a 2019-06-02 stsp local repo="$1"
129 03415a1a 2019-06-02 stsp local msg="$2"
130 03415a1a 2019-06-02 stsp local tree="$3"
131 03415a1a 2019-06-02 stsp (cd $repo && git commit-tree -m "$msg" "$tree")
132 03415a1a 2019-06-02 stsp }
133 03415a1a 2019-06-02 stsp
134 f0fd0aaf 2021-09-14 stsp git_fsck()
135 f0fd0aaf 2021-09-14 stsp {
136 f0fd0aaf 2021-09-14 stsp local testroot="$1"
137 f0fd0aaf 2021-09-14 stsp local repo="$2"
138 f0fd0aaf 2021-09-14 stsp
139 f0fd0aaf 2021-09-14 stsp (cd $repo && git fsck --strict \
140 f0fd0aaf 2021-09-14 stsp > $testroot/fsck.stdout 2> $testroot/fsck.stderr)
141 49c543a6 2022-03-31 naddy ret=$?
142 49c543a6 2022-03-31 naddy if [ $ret -ne 0 ]; then
143 f0fd0aaf 2021-09-14 stsp echo -n "git fsck: "
144 f0fd0aaf 2021-09-14 stsp cat $testroot/fsck.stderr
145 f0fd0aaf 2021-09-14 stsp echo "git fsck failed; leaving test data in $testroot"
146 f0fd0aaf 2021-09-14 stsp return 1
147 f0fd0aaf 2021-09-14 stsp fi
148 f0fd0aaf 2021-09-14 stsp
149 f0fd0aaf 2021-09-14 stsp return 0
150 f0fd0aaf 2021-09-14 stsp }
151 f0fd0aaf 2021-09-14 stsp
152 f6cae3ed 2020-09-13 naddy make_test_tree()
153 0e673013 2019-01-02 stsp {
154 0e673013 2019-01-02 stsp repo="$1"
155 0e673013 2019-01-02 stsp
156 0e673013 2019-01-02 stsp echo alpha > $repo/alpha
157 0e673013 2019-01-02 stsp echo beta > $repo/beta
158 0e673013 2019-01-02 stsp mkdir $repo/gamma
159 0e673013 2019-01-02 stsp echo delta > $repo/gamma/delta
160 0e673013 2019-01-02 stsp mkdir $repo/epsilon
161 0e673013 2019-01-02 stsp echo zeta > $repo/epsilon/zeta
162 0e673013 2019-01-02 stsp }
163 0e673013 2019-01-02 stsp
164 f6cae3ed 2020-09-13 naddy make_single_file_repo()
165 e7303626 2020-05-14 stsp {
166 e7303626 2020-05-14 stsp repo="$1"
167 e7303626 2020-05-14 stsp file="$2"
168 e7303626 2020-05-14 stsp
169 e7303626 2020-05-14 stsp mkdir $repo
170 e7303626 2020-05-14 stsp git_init $repo
171 e7303626 2020-05-14 stsp echo "this is file $file" > $repo/$file
172 e7303626 2020-05-14 stsp (cd $repo && git add .)
173 e7303626 2020-05-14 stsp git_commit $repo -m "intialize $repo with file $file"
174 e7303626 2020-05-14 stsp }
175 e7303626 2020-05-14 stsp
176 f6cae3ed 2020-09-13 naddy get_loose_object_path()
177 e7303626 2020-05-14 stsp {
178 e7303626 2020-05-14 stsp local repo="$1"
179 e7303626 2020-05-14 stsp local id="$2"
180 e7303626 2020-05-14 stsp local id0=`trim_obj_id 38 $id`
181 e7303626 2020-05-14 stsp local idrest=`echo ${id#[0-9a-f][0-9a-f]}`
182 e7303626 2020-05-14 stsp echo "$repo/.git/objects/$id0/$idrest"
183 e7303626 2020-05-14 stsp }
184 e7303626 2020-05-14 stsp
185 f6cae3ed 2020-09-13 naddy get_blob_id()
186 3ce1b845 2019-07-15 stsp {
187 3ce1b845 2019-07-15 stsp repo="$1"
188 3ce1b845 2019-07-15 stsp tree_path="$2"
189 3ce1b845 2019-07-15 stsp filename="$3"
190 3ce1b845 2019-07-15 stsp
191 e8863bdc 2020-07-23 stsp got tree -r $repo -i $tree_path | grep "[0-9a-f] ${filename}$" | \
192 e8863bdc 2020-07-23 stsp cut -d' ' -f 1
193 3ce1b845 2019-07-15 stsp }
194 3ce1b845 2019-07-15 stsp
195 f6cae3ed 2020-09-13 naddy test_init()
196 0e673013 2019-01-02 stsp {
197 0e673013 2019-01-02 stsp local testname="$1"
198 4a1ddfc2 2019-01-12 stsp local no_tree="$2"
199 0e673013 2019-01-02 stsp if [ -z "$testname" ]; then
200 0e673013 2019-01-02 stsp echo "No test name provided" >&2
201 0e673013 2019-01-02 stsp return 1
202 0e673013 2019-01-02 stsp fi
203 e5a14fe3 2020-10-01 stsp local testroot=`mktemp -d "$GOT_TEST_ROOT/got-test-$testname-XXXXXXXX"`
204 0e673013 2019-01-02 stsp mkdir $testroot/repo
205 0e673013 2019-01-02 stsp git_init $testroot/repo
206 4a1ddfc2 2019-01-12 stsp if [ -z "$no_tree" ]; then
207 4a1ddfc2 2019-01-12 stsp make_test_tree $testroot/repo
208 3ce1b845 2019-07-15 stsp (cd $repo && git add .)
209 4a1ddfc2 2019-01-12 stsp git_commit $testroot/repo -m "adding the test tree"
210 4a1ddfc2 2019-01-12 stsp fi
211 c8c71e6e 2020-03-21 stsp touch $testroot/repo/.git/git-daemon-export-ok
212 0e673013 2019-01-02 stsp echo "$testroot"
213 0e673013 2019-01-02 stsp }
214 0e673013 2019-01-02 stsp
215 f6cae3ed 2020-09-13 naddy test_cleanup()
216 0e673013 2019-01-02 stsp {
217 0e673013 2019-01-02 stsp local testroot="$1"
218 fe7842f5 2019-07-14 stsp
219 f0fd0aaf 2021-09-14 stsp git_fsck $testroot $testroot/repo
220 49c543a6 2022-03-31 naddy ret=$?
221 49c543a6 2022-03-31 naddy if [ $ret -ne 0 ]; then
222 f0fd0aaf 2021-09-14 stsp return $ret
223 fe7842f5 2019-07-14 stsp fi
224 fe7842f5 2019-07-14 stsp
225 0e673013 2019-01-02 stsp rm -rf "$testroot"
226 0e673013 2019-01-02 stsp }
227 0e673013 2019-01-02 stsp
228 f6cae3ed 2020-09-13 naddy test_parseargs()
229 7fb414ae 2020-08-08 stsp {
230 6c8da0c6 2020-10-03 naddy while getopts qr: flag; do
231 6c8da0c6 2020-10-03 naddy case $flag in
232 6c8da0c6 2020-10-03 naddy q) export GOT_TEST_QUIET=1
233 6c8da0c6 2020-10-03 naddy ;;
234 6c8da0c6 2020-10-03 naddy r) export GOT_TEST_ROOT=$OPTARG
235 6c8da0c6 2020-10-03 naddy ;;
236 6c8da0c6 2020-10-03 naddy ?) echo "Supported options:"
237 6c8da0c6 2020-10-03 naddy echo " -q: quiet mode"
238 6c8da0c6 2020-10-03 naddy echo " -r PATH: use PATH as test data root directory"
239 6c8da0c6 2020-10-03 naddy exit 2
240 6c8da0c6 2020-10-03 naddy ;;
241 7fb414ae 2020-08-08 stsp esac
242 7fb414ae 2020-08-08 stsp done
243 6c8da0c6 2020-10-03 naddy } >&2
244 7fb414ae 2020-08-08 stsp
245 f6cae3ed 2020-09-13 naddy run_test()
246 0e673013 2019-01-02 stsp {
247 0e673013 2019-01-02 stsp testfunc="$1"
248 7fb414ae 2020-08-08 stsp if [ -z "$GOT_TEST_QUIET" ]; then
249 7fb414ae 2020-08-08 stsp echo -n "$testfunc "
250 7fb414ae 2020-08-08 stsp fi
251 0e673013 2019-01-02 stsp $testfunc
252 0e673013 2019-01-02 stsp }
253 0e673013 2019-01-02 stsp
254 f6cae3ed 2020-09-13 naddy test_done()
255 0e673013 2019-01-02 stsp {
256 0e673013 2019-01-02 stsp local testroot="$1"
257 0e673013 2019-01-02 stsp local result="$2"
258 54c39596 2020-12-28 stsp if [ "$result" = "0" ]; then
259 fe7842f5 2019-07-14 stsp test_cleanup "$testroot" || return 1
260 7fb414ae 2020-08-08 stsp if [ -z "$GOT_TEST_QUIET" ]; then
261 7fb414ae 2020-08-08 stsp echo "ok"
262 7fb414ae 2020-08-08 stsp fi
263 3941b73a 2019-05-14 stsp elif echo "$result" | grep -q "^xfail"; then
264 3941b73a 2019-05-14 stsp # expected test failure; test reproduces an unfixed bug
265 3941b73a 2019-05-14 stsp echo "$result"
266 17201126 2019-07-14 stsp test_cleanup "$testroot" || return 1
267 0e673013 2019-01-02 stsp else
268 0e673013 2019-01-02 stsp echo "test failed; leaving test data in $testroot"
269 0e673013 2019-01-02 stsp fi
270 0e673013 2019-01-02 stsp }